-----------------------------------------------------------------------------------------------
-- Client Lua Script for MediaShare
-- All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"

-----------------------------------------------------------------------------------------------
-- MediaShare Module Definition
-----------------------------------------------------------------------------------------------
if not MediaShare then
	MediaShare = {} 


	--function MediaShare:new(o)
	--    o = o or {}
	 --   setmetatable(o, self)
	--    self.__index = self 

	    -- initialize variables here

	--    return o
	--end

	--function MediaShare:Init()
	    --Apollo.RegisterAddon(self, false)
	--end
	 

	-----------------------------------------------------------------------------------------------
	-- MediaShare OnLoad
	-----------------------------------------------------------------------------------------------
	function MediaShare:OnLoad()
		Apollo.RegisterEventHandler("GenericEvent_MediaShareLoaded", "OnMediaShareLoaded", self)
		
		self.xmlDoc = XmlDoc.CreateFromFile("MediaShare/MediaShare.xml")
		self.wndTexturePicker = Apollo.LoadForm(self.xmlDoc, "TexturePickerFrame", nil, self)
		self.wndTexturePicker:Show(false, true)
		self.wndScrollFrame_TexturePicker = Apollo.LoadForm(self.xmlDoc, "ScrollFrame_TexturePicker", self.wndTexturePicker:FindChild("ScrollFrame"), self)
		
		local ms = MediaShare
		ms.window = self.wndTexturePicker
		ms.frame = self.wndScrollFrame_TexturePicker
		ms.arTextures = {}
		ms.bIsLoaded = true
		Event_FireGenericEvent("GenericEvent_MediaShareLoaded")
	end

	function MediaShare:OnMediaShareLoaded()
		MediaShare.AddTexture("BasicSprites:WhiteFill", "Plain")
		MediaShare.AddTexture("ClientSprites:HoverHealthFull", "Hover")
		MediaShare.AddTexture("BasicSprites:LineFill", "Regular")
		MediaShare.AddTexture("TargetFrameSprites:TargetCastBarFill", "Carbine")
	end

	function MediaShare.AddTexture(newSprite, strName)
		if newSprite == nil or strName == nil then return end
		if not MediaShare.bIsLoaded then MediaShare:OnLoad() end
		
		local ms = MediaShare
		--if ms.arTextures == nil then ms.arTextures = {} end
		ms.arTextures[strName] = newSprite
		
		--table.sort(ms.arTextures, function( a,b ) return a < b end) --cant sort table with strings as key
	end

	function MediaShare.GetTexture(strTexture, callbackFunction, callbackParameters)
		if not MediaShare.bIsLoaded then MediaShare:OnLoad() end
		--[[local ms = MediaShare
		MediaShare.callbackFunction = callbackFunction
		MediaShare.callbackParameters = callBackParameters
		MediaShare.modWindow = wnd
		MediaShare.oldTexture = MediaShare.modWindow:GetSprite()]]
		local oldTexture = strTexture
		local ms = MediaShare
		ms.callbackFunction = callbackFunction
		ms.callbackParameters = callbackParameters
		ms.oldTexture = oldTexture
		ms.newTexture = strTexture
		ms.window:Show(true)
		ms.window:ToFront()
	end


	---------------------------------------------------------------------------------------------------
	-- ScrollFrame_TexturePicker Functions
	---------------------------------------------------------------------------------------------------

	function MediaShare:OnTexturePickerShow( wndHandler, wndControl )
		local wndScrollFrame = self.wndScrollFrame_TexturePicker:FindChild("TextureFrame")
		wndScrollFrame:DestroyChildren()

		local i = 0
		local wnd = nil
		for strName, sprt in pairs(self.arTextures) do
			wnd = Apollo.LoadForm(self.xmlDoc, "Template_Texture", wndScrollFrame, self)
			wnd:SetAnchorPoints(0,0,1,0)
			wnd:SetAnchorOffsets(15,13+(i*26),-15,39+(i*26))
			wnd:FindChild("Backdrop"):FindChild("Bar"):SetSprite(sprt)
			wnd:FindChild("Label"):SetText(strName)
			i = i + 1
		end

		self.wndScrollFrame_TexturePicker:SetAnchorOffsets(0, 0, 0, i*26+47)
	end


	function MediaShare:OnTexturePickerOK( wndHandler, wndControl, eMouseButton )
		if wndControl ~= wndHandler then return end
		
		if type(self.callbackFunction) == "function" then self.callbackFunction(self.newTexture, self.callbackParameters) end
		
		self.callbackFunction = nil
		self.callbackParameters = nil
		self.wndTexturePicker:Show(false)
	end


	function MediaShare:OnTexturePickerCancel( wndHandler, wndControl, eMouseButton )
		if wndHandler ~= wndControl then return end
		--MediaShare.modWindow:SetSprite(MediaShare.oldTexture)
		if type(self.callbackFunction) == "function" then self.callbackFunction(self.oldTexture, self.callbackParameters) end
		
		self.callbackFunction = nil
		self.callbackParameters = nil
		self.wndTexturePicker:Show(false)
	end


	function MediaShare:OnTexturePickerBarButtonUp( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
		if wndControl ~=wndHandler then return end
		if	self.selTextureWnd then 
			self.selTextureWnd:SetBGColor("ff000000")
			--Print("White")
		end
		--self.modWindow:SetSprite(wndHandler:FindChild("Bar"):GetSprite())
		MediaShare.newTexture = wndHandler:FindChild("Bar"):GetSprite()
		MediaShare.selTextureWnd = wndHandler
		wndHandler:SetBGColor("ffffffff")
		--Print(wndHandler:GetName())
		if type(self.callbackFunction) == "function" then self.callbackFunction(self.newTexture, self.callbackParameters) end
	end


	-----------------------------------------------------------------------------------------------
	-- MediaShare Instance
	-----------------------------------------------------------------------------------------------
	--local MediaShareInst = MediaShare:new()
	--MediaShareInst:Init()
end